unit unitAA;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Registry;

type
  TfrmAA = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    Image2: TImage;
    Label2: TLabel;
    txtPass: TEdit;
    Label3: TLabel;
    txtID: TEdit;
    txtEncPass: TEdit;
    cmdApply: TButton;
    cmdOK: TButton;
    cmdCancel: TButton;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure txtPassChange(Sender: TObject);
    procedure cmdApplyClick(Sender: TObject);
    procedure cmdOKClick(Sender: TObject);
    procedure cmdCancelClick(Sender: TObject);
  public
        Reg: TRegistry;
  end;

var
  frmAA: TfrmAA;

implementation

{$R *.DFM}

Function AADecryptPass(Password: String): String;
var
	i: integer;
	ordinal: integer;
	temp: string;
	c: char;
Begin

For i := 1 To Length(Password) do
begin;
	c := Password[i];
	ordinal := 255 - Ord(c);
	temp := temp + Chr(ordinal);
end;
{AllAdvantage uses very weak coding in their passwords.
It's the character of the ASCII value subtracted from 255.
If you're familiar with ASCII, it's not that complicated.}
Result := temp;
End;

procedure TfrmAA.FormCreate(Sender: TObject);
Begin
 Reg := TRegistry.Create;
 Reg.RootKey := HKEY_CURRENT_USER;   {Create registry object}
 Reg.OpenKey('Software\AllAdvantage\Viewbar\Prefs', False);

 txtID.Text := Reg.ReadString('Name'); {Get User ID}
 txtEncPass.Text := Reg.ReadString('Install'); {Get Encrypted password}
 txtPass.Text := AADecryptPass(txtEncPass.Text); {Decrypt password and put in txtPass}
End;

procedure TfrmAA.txtPassChange(Sender: TObject);
Begin
txtEncPass.Text := AADecryptPass(txtPass.Text); {update txtEncPass}
End;

procedure TfrmAA.cmdApplyClick(Sender: TObject);
Begin
try
begin;
If txtPass.Text <> '' Then
        begin
                Reg.WriteString('Install', txtEncPass.Text);
                Reg.WriteString('Name', txtID.Text); {Write new info}
                Reg.CloseKey;
        end
Else
        begin;
                ShowMessage('Fields were left blank.');
        end;
end;

except
        begin;
        {Do nothing}
        end;
end;
{If user click button twice without changing anything, there's an error.
So we use try...except to keep the error from popping up.}
End;

procedure TfrmAA.cmdOKClick(Sender: TObject);
Begin
cmdApply.Click;
Halt(0);  {End}
End;

procedure TfrmAA.cmdCancelClick(Sender: TObject);
Begin
Halt(0);       {End}
End;

End.
